#### Previous topic

scipy.signal.StateSpace.to_zpk

#### Next topic

scipy.signal.TransferFunction.A

# scipy.signal.TransferFunction

class `scipy.signal.``TransferFunction`(*system)

  Linear Time Invariant system class in transfer function form.

  Represents the system as the transfer function \(H(s)=\sum_{i=0}^N b[N-i] s^i / \sum_{j=0}^M a[M-j] s^j\), where \(b\) are elements of the numerator `num`, \(a\) are elements of the denominator `den`, and `N == len(b) - 1`, `M == len(a) - 1`.

  Parameters:

  *system : arguments

  > The `TransferFunction` class can be instantiated with 1 or 2 arguments. The following gives the number of input arguments and their interpretation:

  > > - 1: `lti` system: (`StateSpace`, `TransferFunction` or `ZerosPolesGain`)
  > > - 2: array_like: (numerator, denominator)

  See also

  `ZerosPolesGain`, `StateSpace`, `lti`, `tf2ss`, `tf2zpk`, `tf2sos`

  Notes

  Changing the value of properties that are not part of the `TransferFunction` system representation (such as the `A`, `B`, `C`, `D` state-space matrices) is very inefficient and may lead to numerical inaccuracies.

  Examples

  Construct the transfer function:

  \[H(s) = \frac{s^2 + 3s + 3}{s^2 + 2s + 1}\]

      >>> from scipy import signal
      >>> num = [1, 3, 3]
      >>> den = [1, 2, 1]
      >>> signal.TransferFunction(num, den)
      TransferFunction(
      array([ 1.,  3.,  3.]),
      array([ 1.,  2.,  1.])
      )

  Attributes

  `A` | State matrix of the `StateSpace` system.
  `B` | Input matrix of the `StateSpace` system.
  `C` | Output matrix of the `StateSpace` system.
  `D` | Feedthrough matrix of the `StateSpace` system.
  `den` | Denominator of the `TransferFunction` system.
  `gain` | Gain of the `ZerosPolesGain` system.
  `num` | Numerator of the `TransferFunction` system.
  `poles` | Poles of the `ZerosPolesGain` system.
  `zeros` | Zeros of the `ZerosPolesGain` system.

  Methods

  `bode`([w, n]) | Calculate Bode magnitude and phase data of a continuous-time system.
  `freqresp`([w, n]) | Calculate the frequency response of a continuous-time system.
  `impulse`([X0, T, N]) | Return the impulse response of a continuous-time system.
  `output`(U, T[, X0]) | Return the response of a continuous-time system to input U.
  `step`([X0, T, N]) | Return the step response of a continuous-time system.
  `to_ss`() | Convert system representation to `StateSpace`.
  `to_tf`() | Return a copy of the current `TransferFunction` system.
  `to_zpk`() | Convert system representation to `ZerosPolesGain`.